Name:           obs-studio
Version:        17.0.1
Release:        1.1
Summary:        A recording/broadcasting program

Group:          Multimedia
License:        GPL-2.0
URL:            https://obsproject.com/
Source:         %{name}-%{version}.tar.xz
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

BuildRequires:  cmake >= 2.8.12
BuildRequires:  fontconfig-devel
BuildRequires:  freetype2-devel
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  hicolor-icon-theme
BuildRequires:  libXcomposite-devel
BuildRequires:  libXinerama-devel
BuildRequires:  libXrandr-devel
BuildRequires:  libcurl-devel
BuildRequires:  libjansson-devel
BuildRequires:  libpulse-devel
BuildRequires:  libqt5-qtbase-devel >= 5.3
BuildRequires:  libqt5-qtx11extras-devel >= 5.3
BuildRequires:  libudev-devel
BuildRequires:  libv4l-devel
BuildRequires:  libx264-devel
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(jack)
BuildRequires:  pkgconfig(libavcodec)
BuildRequires:  pkgconfig(libavdevice)
BuildRequires:  pkgconfig(libavfilter)
BuildRequires:  pkgconfig(libavformat)
BuildRequires:  pkgconfig(libavutil)
BuildRequires:  pkgconfig(libswresample)
BuildRequires:  pkgconfig(libswscale)

%description
Open Broadcaster Software is free and open source software for video recording and live streaming.

%package devel
Summary:        A recording/broadcasting program - Development Files
Group:          Development/Multimedia
Requires:       %{name} = %{version}

%description devel
Open Broadcaster Software is free and open source software for video recording and live streaming.

%prep
%setup -q

%build
mkdir -p build && cd build
# does not like cmake macro as it fails to link in math.h (-lm)
cmake \
  -DUNIX_STRUCTURE=1 \
  -DCMAKE_INSTALL_PREFIX=/usr \
  -DOBS_VERSION_OVERRIDE="$(echo "%{version}" | grep -oE "^[^+]+")" \
  ..

%install
cd build
%make_install

# fix lib package locations which are inconsistent since they are 64bit libs, but placed in lib/
%ifarch x86_64
mkdir -p %{buildroot}%{_libdir}/obs-plugins
# needs obs-plugins in lib/ even though 64bit
# mv %%{buildroot}/usr/lib/obs-plugins/* %%{buildroot}%%{_libdir}/obs-plugins
mv %{buildroot}/usr/lib/libobs*.so* %{buildroot}%{_libdir}
%endif

%post   -n %{name} -p /sbin/ldconfig
%postun -n %{name} -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root)
%{_bindir}/obs
# needs obs-plugins in lib/ even though 64bit
%{_usr}/lib/obs-plugins
%{_libdir}/libobs.so.0
%{_libdir}/libobs-frontend-api.so.*
%{_libdir}/libobs-opengl.so.*
%{_libdir}/libobsglad.so.0
%{_datadir}/applications/obs.desktop
%{_datadir}/icons/hicolor/256x256/apps/obs.png
%{_datadir}/obs

%files devel
%defattr(-, root, root)
%{_usr}/lib/cmake
%{_libdir}/libobs.so
%{_libdir}/libobs-frontend-api.so
%{_libdir}/libobs-opengl.so
%{_libdir}/libobsglad.so
%{_includedir}/obs

%changelog
* Tue Jan 17 2017 jimmy@boombatower.com
- Update to version 17.0.1:
  * deps/libff: Fix VP8/VP9/webm alpha support
  * rtmp-services: Increase video bitrate limit for YouTube
  * obs-outputs: fix build error on freebsd
  * Update translations from Crowdin
  * [CI] Use prebuilt deps so we can build on 10.9
  * CI: Build more features into FFMPEG deps
  * CI: Update browser plugin ref and build scripts.
  * CI: Fix zip permission issue on CEF plist files
  * obs-x264: ignore opencl param
  * enc-amf: Update to 1.4.3.8
  * CI: Ability to make packages on travis
  * CI: actually call packagesbuild from the right place 😑
  * cmake: Remove unnecessary find_package calls
  * libobs: Fix scale filtering bug when duplicating scenes
  * win-capture: Don't use FindWindow for game capture keepalive
  * CI: Install Packages and use the full version
  * Revert "win-capture: Use FindWindowEx to traverse window list"
  * obs-filters.c: Fix color correction filter OpenGL crash
  * obs-filters.c: Fix color correction filter saturation
  * Update translations from Crowdin
  * UI: Fix bug with uncopied profile import/export files
  * win-capture: Fix game capture size bug when rehooking
  * libobs: Add func to enum active and inactive child tree
  * libobs: Enumerate full tree when adding active child
  * libobs: Add callback for enumerating all scene children
  * obs-x264: Allow opencl through much longer alias
  * libobs: Update to version 17.0.1
* Mon Dec 26 2016 jimmy@boombatower.com
- Update to version 0.17.0:
  * rtmp-services: Update ingest list for Restream.io
  * Revert "CI: Build on OSX 10.10 on travis"
  * Remove python dep
  * win-capture: Use static runtimes for hooks/helpers
  * cmake: Fix OSX fixup_bundle.sh to copy non-system deps
  * cmake: Fix permissions with OSX fixup_bundle.sh
  * libobs-opengl: Add xcb message poll to empty out the queue
  * frontend-tools: Add options to start output timers every time
  * libobs-d3d11: Add optional macro to log shader disassembly
  * Revert "obs-transitions: Avoid branching in slide_transition.effect"
  * rtmp-services: remove shut down services
  * libff: Allow custom demuxer options
  * obs-outputs: Fix librtmp IP bind / resolve behavior
  * UI: Fix frontend-api event call for adding scenes
  * libobs/util: Add function to get circlebuf data offset
  * libobs/util: Add function to generate formatted filenames
  * libobs: Fix bug where outputs cannot initialize hotkeys
  * cmake: Add _CRT_SECURE_NO_WARNINGS to all projects
  * libobs: Fix deprecated macro
  * libobs/util: Do not ignore deprecation on windows
  * libobs: Use reference counting for encoder packets
  * obs-ffmpeg: Add replay buffer output
  * UI: Disable simple output rec. settings when active
  * UI: Add replay buffer options to simple output mode
  * UI: Clarify replay buf. hotkey error message
  * UI: Separate replay buffer from recording
  * UI: Add file prefix/suffix options for replay buffer
  * UI: Fix replay buffer compile issues on older compilers
  * win-capture: Only duplicate to get cur thread handle
  * win-capture: Always use minimal access rights within hook
  * win-capture: Do not require pipe/mutex within hook
  * win-capture: Fix getting proper UWP window handles
  * win-capture: Use window for keepalive check
  * win-capture: Create all named objects within hook
  * win-capture: Don't use "Local\" for game capture shared mem
  * win-capture: Remove redundant function
  * win-capture: Use wide strings for named objects
  * win-capture: Add ability to open UWP named kernel objects
  * win-capture: Open UWP named objects with helper functions
  * win-capture: Output hook debug messages if addresses missing
  * win-capture: Log plugin-side when capture successful/lost
  * win-capture: Don't hook suspended processes
  * win-capture: Wait a few frames for hook to load
  * win-capture: Fix "attempting to hook [executable]" message
  * win-capture: Add ApplicationFrameHost to game capture blacklist
  * win-capture: Don't hard fail if thread ID not found
  * win-capture: Fix cursor not painting with UWP windows
  * win-capture: Add debug messages when hooking
  * win-capture: Do not fall back to other windows for UWP windows
  * UI: Fix property name bug in frontend API
  * libobs: Fix possible reverse order mutex hard lock
  * UI: Remove deleteLater view from filter window layout
  * libobs: Convert Y800 to RGBX manually
  * UI: Use dedicated GPU on Hybrid AMD GPU systems
  * libobs: Fix format not being set for new source frames
  * libobs: Fix line size issue when copying Y800 data
  * obs-ffmpeg: Don't allow 32kb/s with FFmpeg AAC encoder
  * libobs/graphics: Fix the 2D vector dot product func
  * UI: Make close button default in transform dialog
  * UI: Add ability to copy-paste scene item transforms
  * UI: Add import/export of scene collections & profiles
  * enc-amf: Update to 1.4.3.4 for AMD Driver 16.12.1
  * obs-filters: Improve "Color Correction" filter
  * image-source: Do not change blend state
  * obs-text: Do not reset blend state
  * libobs-d3d11: Don't crash if unable to rebuild shared texture
  * libobs: Increase maximum audio tracks to 6
  * UI: Increase maximum audio tracks to 6
  * UI: Update locale for 6 tracks
  * UI: Fix endif in installer
  * UI: Use 64bit desktop link by default in installer
  * UI: Clarify startup error messages related to video
  * obs-ffmpeg: Fix nvenc_h264 deprecated message
  * libobs: Fix bug drawing RGB/BGR async sources
  * libobs: Process all scene audio actions if no audio playing
  * UI: Fix buddy controls with new audio tracks
  * UI: Add default audio track bitrates
  * UI: Fix video initialization failure error message
  * UI: Fix settings window stacked widget index
  * win-capture: Capture all D3D12 backbuffers
  * win-capture: Use FindWindowEx to traverse window list
  * win-capture: Fix possible null pointer dereference
  * win-capture: Do not add certain windows to window lists
  * win-capture: Add a few new blacklisted game capture exes
  * obs-filters: Add "Color" option to color correction filter
  * obs-filters: Fix comment messages
  * obs-qsv11: Use d3d9 allocator on Win7
  * win-capture: Fix possible access of array beyond size
  * win-capture: Refactor DX12 backbuffer code
  * win-capture: If backbuffer count is 1, disable dxgi 1.4 use
  * win-capture: Release backbuffers immediately upon init
  * libobs/util: Fix C++ compilation issue
  * Add libcaption library
  * libobs: Add ability to insert captions into frames
  * frontend-tools: Move source helper functions to a header
  * frontend-tools: Add caption generation tool (windows)
  * Update translations from Crowdin
  * frontend-tools: Add ability to select caption language
  * frontend-tools: Detach caption thread if critical failure
  * frontend-tools: Reset stop event before starting captions
  * frontend-tools: Don't include colon in "Audio Source"
  * frontend-tools: Set buddied controls for captions dialog
  * libobs: Fix caption encoder packet reallocation
  * libobs: Create referenced parsed AVC encoder packet
  * obs-outputs: Free encoder packet data manually
  * libobs: Fix bug in AVC encoder packet allocation
  * UI: Fix Export QFileDialog parent
  * libobs: Eliminate an unnecessary allocation with captions
  * frontend-tools: Fix output-timer translation bug
  * libobs: Update to version 17.0.0
* Mon Nov 21 2016 jimmy@boombatower.com
- Update to version 0.16.6:
  * UI: Add --verbose and --unfiltered_log command line options
  * libobs: Duplicate filters of a scene when it is is duplicated
  * obs-ffmpeg: Fix assumption about plane height with i444
  * libobs: Refactor check for Windows bitness/arch
  * libobs: Add Windows bitness/arch to crash handler
  * enc-amf: Update to version 1.4.1.5
  * UI: Add preview scaling options
  * rtmp-services: Change YouTube keyint from 4 to 2
  * libobs: Ensure async source sizes are always reset
  * UI: Fix crash when switching encoders in advanced mode
  * UI: Fix scrolling while preview is locked
  * libobs: Ensure AVC priority is always highest for keyframes
  * obs-outputs: Use correct variable for drop priority
  * enc-amf: Update to commit which prevents crash on startup
  * enc-amf: Update to temporary fix branch
  * win-capture: Do not load 64bit hook offsets on 32bit systems
  * win-capture: Defer hook offset loading to separate thread
  * text-freetype2: Defer loading of plugin until source created
  * obs-qsv11: Manually mark priority bits for QSV frames
  * Revert "libobs: Ensure AVC priority is always highest for keyframes"
  * libobs: Update to 0.16.6
  * Update translations from CrowdIn
  * UI: tray icons are redrawn for better visibility and contrast
  * UI: Update settings and fix presets for simple AMD encoder
  * enc-amf: Update to 1.4.2.2
  * enc-amf: Update to 1.4.2.3
  * cmake: Add module to find RSSDK
  * cmake: Add macro to compile .tlb files via midl
  * win-ivcam: Add Intel RealSense plugin
  * UI: Update installer script to latest version
  * libobs-opengl: Add warning when used on windows
  * Update translations from Crowdin
  * enc-amf: Avoid using C++17 for VS2013 compatibility
* Tue Nov  8 2016 jimmy@boombatower.com
- Update to version 0.16.5:
  * libobs-d3d11: Include GDI surface in rebuild
  * libobs-d3d11: Remove possible null pointer dereference
  * libobs: Update to 0.16.5
* Fri Nov  4 2016 jimmy@boombatower.com
- Update to version 0.16.4:
  * libobs/util: Fix get_dll_ver not reporting DLL name
  * Display license in MSI installer
  * rtmp-services: Add Asian Livecoding.tv server and increase video bitrate
  * UI: Enable HiDPI scaling.
  * frontend-tools: Fix crash when adding invalid regex
  * UI: Use Qt lib for screen info instead of x11 libs
  * enc-amf: Update to 1.3.2.3
  * UI: Only scale HiDPI on QT 5.6+
  * enc-amf: Update to 1.3.3.1
  * libobs-d3d11: Log GetDeviceRemovedReason
  * Add 256x256 icon to windows ico for HiDPI displays
  * UI: Add Portable Mode indicator to title bar and log
  * UI: Add raw text and text file to drag&drop support
  * UI: Split Properties window with a QSplitter
  * CMake: Warn if empty QTDIR/DepsPath vars on Windows
  * OSX Travis build
  * CI: Upload artifacts on all pushes
  * CI: Add irc notifications to travis config
  * CI: Reduce travis irc notice to one line
  * CI: Package OSX build into an actual app
  * CI: Use python2 to run package script
  * Build browser plugin on travis for OSX
  * Update obs-browser submodule to a working version
  * obs-frontend-api: Add library version
  * cmake: Fix FFmpeg search path on debian
  * decklink: Update Blackmagic SDK to 10.8.0
  * CI: Build on OSX 10.10 on travis
  * UI: Fix bug in frontend API event
  * frontend-tools: Add output timers
  * frontend-tools: Code cleanup of output timers
  * frontend-tools: Add ability to start timer if output is already active
  * UI: Fix sys. tray crashes when sys. tray not available
  * UI: Fix poor handling of system tray pointers
  * UI: Fix improper brace placement for function
  * UI: Remove unused variable
  * UI: Fix full screen projector on screens that have reserved areas
  * obs-ffmpeg: Add b-frames to NVENC logging
  * UI: Fix --profile option not working on non-windows
  * rtmp-services: Add Picarto
  * libobs/util: Add Get() function to CoTaskMemPtr
  * libobs: Fix missing call to profile_end() when encoding fails
  * libobs: Add date/time to crash handler
  * obs-transitions: Avoid branching in slide_transition.effect
  * obs-ffmpeg: Fix a couple printf compiler warnings.
  * libobs-d3d11: Store dxgi adapter used for device
  * libobs-d3d11: Store compiled shader data (for rebuilding)
  * libobs-d3d11: Correct error message for pixel shaders
  * libobs-d3d11: Store shader samplers as pointers
  * libobs-d3d11: Correct error message for staging surfaces
  * libobs-d3d11: Correct error message creating blend states
  * libobs-d3d11: Store index and add "Start" function
  * libobs-d3d11: Clear device state before unloading
  * libobs-d3d11: Store swap initialization data (for rebuilding)
  * libobs-d3d11: Store device adapter index (for rebuilding)
  * libobs-d3d11: Store static textures in RAM (for rebuilding)
  * libobs-d3d11: Store static vertex buffer data (for rebuilding)
  * libobs-d3d11: Save all D3D11 object descriptors (for rebuilding)
  * libobs-d3d11: Make shared texture error message less vague
  * libobs-d3d11: Use linked list for all objects (for rebuilding)
  * libobs-d3d11: Remove unused function
  * libobs-d3d11: Add Release funtions to all GS objects
  * libobs-d3d11: Rebuild device and assets if device removed/reset
  * win-capture: Cache cursor textures to prevent reallocation
  * win-capture: Use IUnknown for getting swap backbuffers
  * win-capture: Add D3D12 capture support
  * UI: Allow the ability to use deprecated sources
  * UI: Add AMD presets and update settings
  * enc-amf: Update to release 1.4.0.0
  * Update translations from CrowdIn
  * libobs: Update to version 0.16.3
  * win-mf: Deprecate AMD Media Foundation H.264 encoder
  * UI: Fix tab order of Crop fields in Transform Properties
  * enc-amf: Update to Version 1.4.1.0
  * Revert "UI: Only scale HiDPI on QT 5.6+"
  * Revert "UI: Enable HiDPI scaling."
  * enc-amf: Fix VS2013 compiling issue
  * libobs: Update to version 0.16.4
- Expand libobs-frontend-api.so to include all versions in %%files.
- After upstream fix place libobs-(opengl|frontend-api).so in devel.
* Thu Sep 29 2016 jimmy@boombatower.com
- Update to version 0.16.2:
  * obs-ffmpeg: Fix possible NVENC crash
  * UI: Use rect intersection test for validating position
  * enc-amf: Update submodule to 1.3.1.0
  * obs-text: Add gradient feature
  * enc-amf: Fix warnings caused by warnings( push/pop )
  * libobs: Update to 0.16.2
* Thu Sep 29 2016 jimmy@boombatower.com
- Update to version 0.16.1:
  * UI: Fix window size/pos not saving on exit
  * libobs/util: Fix fread_utf8 not working with files < 3 bytes
  * obs-text: Change file update interval to 1 sec (from 2)
  * libobs: Update to 0.16.1
* Wed Sep 28 2016 jimmy@boombatower.com
- Update to version 0.16.0:
  * enc-amf: Update submodule to 1.3.0
  * UI: Add media/image file drop support
  * enc-amf: Update submodule to 1.3.0.1
  * obs-browser: Add browser plugin as a submodule
  * enc-amf: Update submodule to 1.3.0.3
  * libobs: Update version to 0.16.0
  * enc-amf: Remove unused locale files
  * Update translations from Crowdin
  * UI: Just use 'OK' button for license agreement dialog
* Mon Aug  8 2016 jimmy@boombatower.com
- Update to 0.15.4 release.
* Sat Jul 16 2016 jimmy@boombatower.com
- Update to 0.15.2 release.
* Tue Jul 12 2016 jimmy@boombatower.com
- Update to 0.15.1 release.
* Fri Jul  8 2016 jimmy@boombatower.com
- Update to 0.15.0 release.
* Mon May 16 2016 jimmy@boombatower.com
- Update to 0.14.2 release.
* Tue Apr 26 2016 jimmy@boombatower.com
- Update to 0.14.1 release.
* Sat Apr 16 2016 olaf@aepfle.de
- Use pkgconfig instead of libffmpeg-devel
* Tue Mar 22 2016 jimmy@boombatower.com
- Update to 0.13.4 release.
* Sun Mar 20 2016 jimmy@boombatower.com
- Update to 0.13.3 release.
* Mon Feb 29 2016 jimmy@boombatower.com
- Update to 0.13.2 release.
* Fri Feb  5 2016 jimmy@boombatower.com
- Update to 0.13.1 release.
- Remove patch for gcc 4.8 compatability since it was upstreamed.
* Thu Jan 28 2016 jimmy@boombatower.com
- Update to 0.13.0 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.13.0
- Add rpmlintrc for "bad" things obs-studio requires.
- Add patch for gcc 4.8 compatability.
* Sat Dec 12 2015 jimmy@boombatower.com
- Update to 0.12.4 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.12.4
* Wed Dec  9 2015 jimmy@boombatower.com
- Change build requirement from libffmpeg-devel to ffmpeg-devel to
  follow recent linking of ffmpeg to obs version.
* Sat Dec  5 2015 jimmy@boombatower.com
- Update to 0.12.3 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.12.3
* Sat Nov 21 2015 jimmy@boombatower.com
- Update to 0.12.2 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.12.2
* Tue Nov 17 2015 jimmy@boombatower.com
- Update to 0.12.1 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.12.1
* Fri Sep 25 2015 jimmy@boombatower.com
- Update to 0.12.0 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.12.0
- Remove gcc >= 4.9 requirement since 0.12.0 reverted unintended change.
* Mon Aug 17 2015 jimmy@boombatower.com
- Update to 0.11.4 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.11.4
- Cut off git portion of version string in UI.
- Since 0.11.3 obs unofficially requires gcc 4.9 and higher which makes it
  impossible to compile on obs for openSUSE 13.2.
  https://obsproject.com/mantis/view.php?id=276
* Sun Aug  9 2015 jimmy@boombatower.com
- Update to 0.11.3 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.11.3
* Tue Jul 28 2015 jimmy@boombatower.com
- Update to 0.11.2 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.11.2
* Fri Jul 10 2015 jimmy@boombatower.com
- Update to 0.11.1 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.11.1
* Thu Jul  9 2015 jimmy@boombatower.com
- Update to 0.11.0 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.11.0
- Add curl build dependency.
* Tue May 19 2015 jimmy@boombatower.com
- Update to 0.10.1 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.10.1
* Wed May 13 2015 jimmy@boombatower.com
- Update to 0.10.0 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.10.0
* Fri Mar 27 2015 jimmy@boombatower.com
- Update to 0.9.1 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.9.1
* Thu Mar 26 2015 jimmy@boombatower.com
- Update to 0.9.0 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.9.0
* Sat Feb 21 2015 jimmy@boombatower.com
- Update to 0.8.3 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.8.3
* Thu Feb 12 2015 jimmy@boombatower.com
- Update to 0.8.2 release.
  https://github.com/jp9000/obs-studio/releases/tag/0.8.2
  https://github.com/jp9000/obs-studio/releases/tag/0.8.1
  https://github.com/jp9000/obs-studio/releases/tag/0.8.0
* Thu Jan 15 2015 jimmy@boombatower.com
- Update to 0.7.3 release.
  Details at https://github.com/jp9000/obs-studio/releases/tag/0.7.3
* Wed Jan  7 2015 jimmy@boombatower.com
- Update to 0.7.2 release.
  Details at https://github.com/jp9000/obs-studio/releases/tag/0.7.2 and
    https://github.com/jp9000/obs-studio/releases/tag/0.7.1
* Thu Nov 13 2014 jimmy@boombatower.com
- Initial 0.6.4 release.
